#
# Simulate a Dawn RuSH system monitor
#
import SocketServer, time

class DummyCrate(SocketServer.BaseRequestHandler):
    def handle(self):
        then = time.time()
        poh = 23.5
        text = 'abcdef'
        t = [ 35, 35, 35, 35 ]
        tMax = 35
        v = [ 3333, 5000, 12000, 12000 ]
        fan = range(9)
        ps1 = 0
        ps2 = 0
        tScale = 1.0
        vScale = 1.0
        fScale = 1.0
        self.request.send('Ver 64-1013426D14\r\000\n'
                       '\r\000\n'
                       'Total System Hrs = 3.2\r\000\n'
                       'Code Ver 64-1013426D14\r\000\n'
                       'Code Base O\r\000\n'
                       'Hardware Part # 06-1013426\r\000\n'
                       '\r\000\n'
                       'XPORT Ver 01.60\r\000\n'
                       'IP Add = 192.168.000.002\r\000\n'
                       'MAC Add = 00-20-4A-81-78-C2\r\000\n'
                       'National Semi Temp Sensors\r\000\n'
                       '\r\000\n'
                       'S/N = 12345677\r\000\n'
                       'Unit Name =\r\000\n'
                       'PW req for ENET\r\000\n'
                       'ENET input allowed\r\000\n'
                       'PW req for RS-232 TCP Mode. In and Out ports = 23\r\000\n'
                       'Voltage Monitoring = Y\r\000\n'
                       'Mon 3.3V = Y\r\000\n'
                       'Num Temp Sensors = 3\r\000\n'
                       'Num Fans = 0\r\000\n'
                       'Data Sent to Serial Port = N\r\000\n'
                       'Error Status Changes to Serial/Network Port = N\r\000\n'
                       '\r\000\n'
                       '5V Min 4875\r\000\n'
                       '5V Max 5250\r\000\n'
                       '3.3V Min 3250\r\000\n'
                       '3.3V Max 3450\r\000\n'
                       '12V Min 11640\r\000\n'
                       '12V Max   12600\r\000\n'
                       '-12V Min 11640\r\000\n'
                       '-12V Max 12600\r\000\n'
                       'Temp Warn 40\r\000\n'
                       'Temp Max 50\r\000\n'
                       'Shut Down PS on Overtemp = N\r\000\n'
                       'Shut Down PS on Overvoltage (10% over MaxLimit) = N\r\000\n'
                       'Open Contacts to Shutdown Supply\r\000\n'
                       'Current Sensor Connected = N\r\000\n'
                       'Detect Power Switch = N\r\000\n'
                       '\r\000\n')
        self.showMenu()

        while 1:
            nchar = self.request.recv(1)
            if(len(nchar) == 0):
               break
            text = text[1:6] + nchar
            if (text[5] == 'Q'):
                for i in range(4):
                    t[i] = 20 + (tScale * (16 + 2 * i))
                tScale += 0.05
                if (tScale >= 2): tScale = 1.0
                if (t[3] > tMax): tMax = t[3]
                if (ps1 or ps2):
                    v[0] = 3333 * vScale
                    v[1] = 5000 * vScale
                    v[2] = 12000 * vScale
                    v[3] = 12000 * vScale
                else:
                    v[0] = 0
                    v[1] = 0
                    v[2] = 0
                    v[3] = 0
                vScale += 0.01
                if (vScale >= 1.15): vScale = 0.85
                for i in range(9):
                    fan[i] = 200 + (fScale * (1000 + 10 * i))
                fScale += 0.05
                if (fScale >= 2.5): fScale = 0.5
                self.request.send(':SN=8765    ,UN=APEX1,IP=128.127.126.131,V3=%d,V5=%d,V+12=%d,V-12=%d,'
                    'T1=%d,T2=%d,T3=%d,T4=%d,'
                    'F1=%d,F2=%d,F3=%d,F4=%d,F5=%d,F6=%d,F7=%d,F8=%d,F9=%d,'
                    'OT=0,OV=0,OC=0000,'
                    'PS1=%d,PS2=%d,MSG=0,SW=1,'
                    'PROT=TEL ,I3=00,I5=00,I12=00,I-12=00,CODE=64-113426F39,ENET=D6.10,'
                    'POH=%.1f,MAXTMP=%d,MINTMP=21,PROC=31,LOAD=FF,PWRCYCL=00003\r\000\n' %
                           (v[0], v[1], v[2], v[3],
                            t[0], t[1], t[2], t[3],
                            fan[0], fan[1], fan[2], fan[3], fan[4],
                            fan[5], fan[6], fan[7], fan[8], 
                            ps1, ps2,
                            poh + ((time.time() - then) / 3600),
                            tMax,))
                self.request.send(';EVXXXXXXXXETYYYYYYYYYEFZZZZZZZZZPSbbMSGbSWb\r\000\n')
            else:
                self.request.send(nchar)
                if (text[2:6] == "PSON"):
                    ps1 = 1
                    ps2 = 1
                elif (text[1:6] == "PS1ON"):
                    ps1 = 1
                elif (text[1:6] == "PS2ON"):
                    ps2 = 1
                elif (text[1:6] == "PSOFF"):
                    ps1 = 0
                    ps2 = 0
                elif (text[0:6] == "PS1OFF"):
                    ps1 = 0
                elif (text[0:6] == "PS2OFF"):
                    ps2 = 0

    def showMenu(self):
        self.request.send('\r\000\nEnter\r\000\n')
        self.request.send('1 to Change Voltage, Temperature Limits\r\000\n')
        self.request.send('2 Reset to +5%/-2.5% limits\r\000\n')
        self.request.send('3 Reset to +5%/-5% limits\r\000\n')
        self.request.send('4 Change which parameters are sensed (and how)\r\000\n')
        self.request.send('5 Maintenance\r\000\n')

server = SocketServer.TCPServer(('', 8000), DummyCrate)
server.serve_forever()
